<script type="text/javascript">
  RED.nodes.registerType("dim-xml-conf", {
    category: 'config',
    defaults: {
      host: { value: "", required: true },
      port: { value: RED._('node-red-dim-xml/dimXmlConf:dimXmlConf.default.port'),
        validate: RED.validators.number(true) },
      retry: { value: RED._('node-red-dim-xml/dimXmlConf:dimXmlConf.default.retry'),
        validate: function(r) {
          return ((r === "") || (RED.validators.number(r) && (r >= 1000)));
        }
      }
    },
    inputs: 0,
    outputs: 0,
    label: function() {
      let lbl = this.host + ":";
      lbl += this.port ? this.port :
        this._('node-red-dim-xml/dimXmlConf:dimXmlConf.default.port');
      return lbl;
    }
  });
</script>

<script type="text/html" data-template-name="dim-xml-conf">
  <div class="form-row">
    <label for="node-config-input-host">
      <i class="fa fa-globe"></i>
      <span data-i18n="dimXmlConf.label.host"></span>
    </label>
    <input type="text" id="node-config-input-host" data-i18n="[placeholder]dimXmlConf.default.host">
  </div>
  <div class="form-row">
    <label for="node-config-input-port">
      <span data-i18n="dimXmlConf.label.port"></span>
    </label>
    <input type="text" id="node-config-input-port" data-i18n="[placeholder]dimXmlConf.default.port">
  </div>
  <div class="form-row">
    <label for="node-config-input-retry">
      <i class="fa fa-repeat"></i>
      <span data-i18n="dimXmlConf.label.retry"></span>
    </label>
    <input type="text" id="node-config-input-retry" data-i18n="[placeholder]dimXmlConf.default.retry" style="width:100px;">
    <label for="node-config-input-retry">
      <span data-i18n="dimXmlConf.label.retry-unit"></span>
    </label>
  </div>
</script>

<!-- DIM-XML Nodes' edit dialog template -->
<script id="dim-xml-node-inputs" type="text/x-handlebars-template">
  {{#with nodeName}}
    {{#ifDef property label}}
      <div class="form-row">
        <label for="node-input-{{property}}"><i class="fa fa-tag"></i>  {{label}}</label>
        <input type="text" id="node-input-{{property}}" data-i18n="[placeholder]node-red-dim-xml/dimXmlConf:dimXmlConf.placeholder.node-name">
      </div>
    {{/ifDef}}
  {{/with}}
  {{#with nodeConf}}
    {{#ifDef property label}}
      <div class="form-row" data-dim-id="config-node-input">
        <label for="node-input-{{property}}"><i class="fa fa-globe"></i>  {{label}}</label>
        <input type="text" id="node-input-{{property}}">
        <div class="dim-loader" style="display:none;"></div>
      </div>
      <div data-dim-id="config-node-notification-area" style="display:none;"></div>
    {{/ifDef}}
  {{/with}}
  {{#with service}}
    {{#ifDef property label}}
      <div class="form-row">
        <label for="node-input-{{property}}">{{label}}</label>
        <input type="text" id="node-input-{{property}}" data-dim-id="service-input" data-i18n="[placeholder]node-red-dim-xml/dimXmlConf:dimXmlConf.placeholder.service" list="service-list">
        <datalist id="service-list">
        </datalist>
      </div>
      <div data-dim-id="service-notification-area" style="display:none;"></div>
    {{/ifDef}}
  {{/with}}
  {{#with serviceName}}
    {{#ifDef property label}}
      <div class="form-row">
        <label for="node-input-{{property}}">{{label}}</label>
        <input type="text" id="node-input-{{property}}" data-i18n="[placeholder]node-red-dim-xml/dimXmlConf:dimXmlConf.placeholder.service-name">
      </div>
    {{/ifDef}}
  {{/with}}
  {{#each serviceDefinitions}}
    {{#ifDef property label}}
      <div class="form-row">
        <label for="node-input-{{property}}">{{label}}</label>
        <input type="text" id="node-input-{{property}}" data-i18n="[placeholder]node-red-dim-xml/dimXmlConf:dimXmlConf.placeholder.service-definition" list="serviceDef-list">
        <datalist id="serviceDef-list">
          <option value="C - string">
          <option value="S:1 - int16">
          <option value="I:1 - int32">
          <option value="X:1 - int64">
          <option value="F:1 - float">
          <option value="D:1 - double">
        </datalist>
      </div>
    {{/ifDef}}
  {{/each}}
  {{#each checkboxes}}
    {{#ifDef property label}}
      <div class="form-row" style="padding-right:50px; {{#if inline}}display:inline-block;{{/if}}">
        <label for="node-input-{{property}}">{{label}}</label>
        <input type="checkbox" id="node-input-{{property}}" style="width:15px; vertical-align:baseline;">
      </div>
    {{/ifDef}}
  {{/each}}
  {{#each stdInputs}}
    {{#ifDef property label}}
      <div class="form-row" id="div-node-input-{{property}}">
        <label for="node-input-{{property}}" style="vertical-align:top;">
          <i class="{{icon}}"></i>
          {{label}}
        </label>
        <input type="text" id="node-input-{{property}}" placeholder="{{placeholder}}" {{#if width}}style="width:{{width}};"{{/if}}>
        <label for="node-input-{{property}}">{{unit}}</label>
      </div>
    {{/ifDef}}
  {{/each}}
  {{#with orderedList}}
    {{#if label}}
      <div class="form-row node-div-ordered-list-row">
        <label>{{label}}</label>
        <ol data-id="node-input-ordered-list"></ol>
      </div>
      {{#if selector}}
      <div class="form-row">
        <label data-id="node-label-ol-selector"></label>
        <select data-id="node-input-ol-selector" style="width:80px"></select>
      </div>
      {{/if}}
    {{/if}}
  {{/with}}
</script>

<style>
  .dim-msg-error{
    background-color: #d6615f;
    text-align: center;
    color: white;
    border-radius: 4px;
    padding: 10px;
    position: relative;
    left: 110px;
    display: inline-block;
    margin-bottom: 12px;
  }

  .dim-msg-error::before{
    content: '';
    height: 0px;
    width: 0px;
    border-left: 7px solid transparent;
    border-right: 7px solid transparent;
    border-bottom: 7px solid #d6615f;
    position: absolute;
    top: -7px;
  }

  .form-row .dim-loader{
    display: inline-block;
    position: relative;
    top: 8px;
    left: 4px;
    width: 12px;
    height: 12px;
    border: 4px solid rgb(212, 207, 207);
    border-radius: 50%;
    border-top: 4px solid grey;
    animation: dim-spin 2s linear infinite;
  }

  @keyframes dim-spin {
    0% { transform: rotate(0deg); }
    100% { transform: rotate(360deg); }
  }
</style>

<!-- DIM-XML Nodes' utilities -->
<script type="text/javascript">
  if (!window.dimXmlPromise) {
    const prom = {};
    prom.promise = new Promise((resolve) => (prom.resolve = resolve));
    window.dimXmlPromise = prom;
  }
  const
    dimXmlTemplatesProm = $.getScript('https://cdnjs.cloudflare.com/ajax/libs/handlebars.js/4.7.6/handlebars.min.js')
    .then(function() {
      Handlebars.registerHelper('ifDef', function(a, b, options) {
        if (a && b && typeof(a) === "string" && typeof(b) === "string") {
          return options.fn(this);
        }
      });

      return Handlebars.compile(
        document.getElementById("dim-xml-node-inputs").innerHTML);
    }),

    dimXml = {
      utils: {
        genNodeTemplate: async function(nodeType, fields) {
          const template = await dimXmlTemplatesProm;
          const nodeTemplate = $('script[data-template-name="' + nodeType + '"]');
          nodeTemplate.text(template(fields) + nodeTemplate.text());
        },
        /**
         * @brief retrieve list of services from the selected DNS Server
         * @return {?Promise<Array<{ name:string, definition:string, type:string }>}
         */
        serviceList: function() {
          const confInput = $('div[data-dim-id=config-node-input]')
            .find('select[id|=node-input]');
          const srvInput = $('input[data-dim-id=service-input]');
          const srvNotif = $('div[data-dim-id=service-notification-area]');

          if (confInput.length === 1 && srvInput.length === 1) {
            const confNode = confInput.children('option:selected');
            if (confNode.val() !== '_ADD_') {
              const dnsServer = confNode.text();
              confInput.prop('disabled', true);
              $('.dim-loader').show();

              return $.ajax({
                url: "service-list/" + dnsServer,
                type:"GET",
              })
              .then(
                function(res) { /* success */
                  confInput.prop('disabled', false);
                  $('.dim-loader').hide();

                  return res.list || [];
                },
                function(jqXHR, textStatus, errorThrown) { /* error */
                  confInput.prop('disabled', false);
                  $('.dim-loader').hide();

                  if (jqXHR.status == 500) {
                    srvInput.attr('class', 'input-error');
                    srvNotif.addClass('dim-msg-error')
                    .text(RED._('node-red-dim-xml/dimXmlConf:dimXmlConf.error.service-list'))
                    .show('fast', function() {
                      srvInput.one('keypress', () => srvNotif.hide('fast'));
                    });
                  }
                  else if (jqXHR.status == 0) {
                    RED.notify(RED._("node-red:common.notification.error",
                      { message: RED._("node-red:common.notification.errors.no-response") }),
                      "error");
                  }
                  else {
                    RED.notify(RED._("node-red:common.notification.error",
                      { message: RED._("node-red:common.notification.errors.unexpected",
                      { status: jqXHR.status, message: textStatus }) }), "error");
                  }
                  return [];
                }
              );
            }
          }
          return null;
        },
        /**
         * @brief initialize the service drop-down list
         * @return {?{
         *  clear: () => void,
         *  append: (Array<string>) => void
         * }}
         */
        initDropDownList: function() {
          const confInput = $('div[data-dim-id=config-node-input]')
            .find('select[id|=node-input]');
          const srvInput = $('input[data-dim-id=service-input]');
          const srvDataList = $('#service-list');

          if (confInput.length === 1 && srvInput.length === 1) {

            const confNotif =
              $('div[data-dim-id=config-node-notification-area]');
            const srvNotif =
              $('div[data-dim-id=service-notification-area]');

            srvInput.focus(function() {
              if (confInput.children('option:selected').val() === '_ADD_') {
                this.setAttribute('class', 'input-error');
                this.readOnly = true;

                confNotif.addClass('dim-msg-error')
                .text(RED._('node-red-dim-xml/dimXmlConf:dimXmlConf.error.dns-server-missing'))
                .show('fast');
              }
            });

            return {
              clear: () => {
                /* notifications and inputs cleanup */
                confNotif.hide('fast');
                srvNotif.hide('fast');
                srvInput.attr('readOnly', false).val('');
                srvDataList.empty();
              },
              append: (srvList) => {
                if (Array.isArray(srvList)) {
                  let services = [];

                  srvList.forEach(s => { services.push($('<option>').val(s)); });
                  srvDataList.append(services);
                }
              }
            }
          }
          return null;
        },
        getSingleValue: function(node) {
          if (node.changed) {
            return RED.notify(RED._("notification.warning",
              { message: RED._("notification.warnings.undeployedChanges") }),
              "warning");
          }

          let nodeLabel = node._def.label.call(node);
          if (nodeLabel.length > 38) {
            nodeLabel = nodeLabel.substring(0, 50) + "...";
          }
          nodeLabel = nodeLabel.replace(/&/g,"&amp;")
            .replace(/</g,"&lt;").replace(/>/g,"&gt;");

          $.ajax({
            url: node.type + "/" + node.id,
            type:"POST",
            success: function(resp) {
              RED.notify(node._('node-red-dim-xml/dimXmlConf:dimXmlConf.success.value-fetched',
                { node: nodeLabel }), { type: "success", id: "dimXmlConf" });
            },
            error: function(jqXHR, textStatus, errorThrown) {
              if (jqXHR.status == 404) {
                RED.notify(node._("node-red:common.notification.error",
                  { message: node._("node-red:common.notification.errors.not-deployed") }),
                  "error");
              }
              else if (jqXHR.status == 500) {
                RED.notify(node._("node-red:common.notification.error",
                  { message: node._('node-red-dim-xml/dimXmlConf:dimXmlConf.error.fetch-failed') }),
                  "error");
              }
              else if (jqXHR.status == 0) {
                RED.notify(node._("node-red:common.notification.error",
                  { message: node._("node-red:common.notification.errors.no-response") }),
                  "error");
              }
              else {
                RED.notify(node._("node-red:common.notification.error",
                  { message: node._("node-red:common.notification.errors.unexpected",
                  { status: jqXHR.status, message: textStatus }) }), "error");
              }
            }
          });
        },
        getLabel: function(node, defaultLabel) {
          if (node) {
            let suffix = "";
            if (node.hasOwnProperty('monitored') &&
              node.hasOwnProperty('scheduled')) {
              if (!node.monitored && !node.scheduled) {
                suffix = " \u00B9"; /* superscript one (¹) */
              }
              else if (node.scheduled) {
                suffix = " \u21BB"; /* clockwise open circle arrow (↻) */
              }
            }
            return (node.name || node.serviceName || defaultLabel) + suffix;
          }
          else {
            return defaultLabel;
          }
        },
        enableInputByCheckbox: function(node, input, checkbox) {
          if (node && typeof(input) === 'string' && typeof(checkbox) === 'string') {
            const inputField = $('#div-node-input-' + input);

            if (node[checkbox] === true) {
              inputField.show();
            }
            else {
              inputField.hide();
            }

            $('#node-input-' + checkbox).on("change", function() {
              if ($(this).prop("checked")) {
                inputField.show();
              }
              else {
                inputField.hide();
              }
            });
          }
        },
        resizeDialog: function(size) {
          const dialogForm = $('#dialog-form');
          let height = dialogForm.outerHeight();
          let rows = dialogForm.children("div:not(.node-div-ordered-list-row):visible");
          for (let i = 0; i < rows.length; i++) {
            height -= $(rows[i]).outerHeight(true);
          }
          var editorRow = dialogForm.children("div.node-div-ordered-list-row");
          height -= (parseInt(editorRow.css("marginTop")) +
            parseInt(editorRow.css("marginBottom")));
          dialogForm.find('ol[data-id="node-input-ordered-list"]').editableList('height', height - 10);
        }
      },
      regExp: {
        srvName: "^\\b(?:[A-Za-z0-9][\\w-+.:]*)(?:\\/[A-Za-z0-9][\\w-+.:]*)*$",
        srvDefFormat: "(?:[ICLSFDX]\\:[1-9]\\d*\\;)*[ICLSFDX](?:\\:[1-9]\\d*)?",
        uint: /^(0|[1-9][0-9]*)$/,
        int: /^(0|[-]?[1-9][0-9]*)$/
      }
    },
    disXml = {
      regExp: {
        srvName: new RegExp(dimXml.regExp.srvName),
        srvDefFormat: new RegExp("^\\b" + dimXml.regExp.srvDefFormat + "$"),
        srvDefDescr: /\s\-\s(?:string|int16|int32|int64|float|double)/,
      },
      DataType: {
        NESTED: 0, INT32: 1, DOUBLE: 2, STRING: 3, INT64: 4, ENUM: 5,
        INT8: 6, INT16: 7, FLOAT: 8, BOOL: 9, UINT32: 11, UINT64: 14,
        UINT8: 16, UINT16: 17
      },
      editor: {
        nestedType: "_dim-xml-editor-nested",
        enumType: "_dim-xml-editor-enum",
        template:
          `<script type="text/x-red" data-template-name="_dim-xml-editor">
            <div data-id="ordered-list-label" style="padding-bottom:5px">
            </div>
            <div class="form-row node-div-ordered-list-row">
              <ol data-id="node-input-ordered-list"></ol>
            </div>
            <div class="form-row ordered-list-selector" style="display:none">
              <label data-id="node-label-ol-selector"></label>
              <select data-id="node-input-ol-selector" style="width:80px"></select>
            </div>
          <\/script>`,
        /**
         * @typedef {{ value: number, name: string }} EnumData
         *
         * @param {{
         *  firstValue?: number | string  | null,
         *  negativeValue?: boolean | null,
         *  selectorLabel?: string  | null,
         *  valueLabel?: string | null,
         *  strValueLabel?: string | null,
         *  listLabel?: string | null,
         *  parentName?: string | null,
         *  valueWidth?: string | null
         * }} [options]
         * @return {{
         *  save: () => { list: Array<EnumData>, value: number, valueName: string },
         *  load: (data: { list: Array<EnumData>, value: number }) => void
         * }}
         */
        buildEnumList: function(options) {
          opts = options || {}; /* default options */
          const regexp = opts.negativeValue ?
            dimXml.regExp.int : dimXml.regExp.uint;

          const dialogForm = $('#dialog-form');
          const ol = dialogForm
            .find('ol[data-id="node-input-ordered-list"]');
          const selector = dialogForm
            .find('select[data-id="node-input-ol-selector"]');
          const selectorLbl = dialogForm
            .find('label[data-id="node-label-ol-selector"]');

          if (opts.listLabel) {
            dialogForm.find('div[data-id="ordered-list-label"]')
            .text(opts.listLabel +
              (opts.parentName ? ' [ ' + opts.parentName + ' ]' : ''));
          }
          selectorLbl.text(opts.selectorLabel)
          dialogForm.find('div.ordered-list-selector').show();

          let maxValue = parseInt(opts.firstValue) - 1 || -1;
          let selectedVal;

          const interColPad = '10px';
          const lpad = '30px';

          ol.css({
            minWidth: '480px',
            minHeight: '120px'
          })
          .editableList({
            header: $('<div>')
              .append($('<div>')
              .text(opts.valueLabel || 'Value')
              .css({
                paddingLeft: lpad,
                width: opts.valueWidth || '80px',
                display: 'inline-block'
              }))

              .append($('<div>')
              .text(opts.nameLabel || 'String')
              .css({
                paddingLeft: interColPad,
                display: 'inline-block'
              })),
            addItem: function(row, index, data) {

              /* prepare and add a row to the container */
              row.css({
                overflow: "hidden",
                whiteSpace: "nowrap"
              });

              const listItem = $('<div>').appendTo(row);
              const elem = $('<div>').appendTo(listItem);

              const value = $('<input>').attr('type', 'text')
                .addClass('node-input-enum-value')
                .css({
                  display: 'inline-block',
                  width: opts.valueWidth
                })
                .appendTo(elem)
                .typedInput({ type: 'int', types: [ { value: "int",
                  label: "int",
                  icon: "red/images/typedInput/09.png",
                  validate: regexp } ]
                });

              $('<div>').css({
                paddingLeft: interColPad,
                display: 'inline-block'
              }).appendTo(elem);

              const name = $('<input>').attr('type', 'text')
                .css({
                  width: 'calc(100% - ' + opts.valueWidth + ' - ' +
                    interColPad + ')',
                  display: 'inline-block'
                })
                .addClass('node-input-enum-name')
                .appendTo(elem)
                .typedInput({ type: 'str'});

              /* insert data */
              if (!data.hasOwnProperty('value')) {
                data = { value: ++maxValue, name: "" };
              }
              value.attr('data-prev', data.value).typedInput('value', data.value);
              name.typedInput('value', data.name);

              /* update item data */
              $(row).data('data', data);

              selector.append($('<option>').val(data.value).text(data.value));

              const changeValue = function() {
                const v = $(this).typedInput('value');
                const prev = $(this).attr('data-prev');
                let err = "";
                if (regexp.test(v)) {
                  /* check for duplicate values */
                  if (selector.find('option[value="' + v + '"]').length === 0) {
                    /* update data and prev value*/
                    $(row).data('data').value = v;
                    $(this).attr('data-prev', v);

                    /* update select list */
                    let opts = [];
                    const items = ol.editableList('sort')
                      .editableList('items');
                    items.each(function() {
                      const v = $(this).find('.node-input-enum-value').val();
                      opts.push($('<option>').val(v).text(v));
                    });

                    /* update selected value */
                    if (selectedVal === prev) {
                      selectedVal = v;
                    }
                    selector.empty().append(opts)
                    .find('option[value="' + selectedVal + '"]')
                    .prop('selected', true);

                    maxValue = selector.find(':last-child').val();
                  }
                  else {
                    err = RED._('node-red-dim-xml/dimXmlConf:dimXmlConf.error.dup-value');
                  }
                }
                else {
                  err = RED._('node-red-dim-xml/dimXmlConf:dimXmlConf.error.invalid-value');
                }

                if (err) {
                  /* avoids indefinite recursion */
                  $(this).off('change').typedInput('value', prev);
                  $(this).on('change', changeValue);
                  $('<div>').addClass('dim-msg-error')
                  .css({ top: '7px', left: '15px', marginBottom: '7px',
                    display: 'none' })
                  .text(err).appendTo(listItem).show('fast').delay(3000)
                  .hide('fast', function() {
                    $(this).remove();
                  });
                }
              }
              value.on('change', changeValue);
              ol.editableList('show', $(row).data('data')); /* scroll on Add */
            },
            sort: function(dataA, dataB) {
              if (dataA.value && dataB.value) {
                return dataA.value - dataB.value;
              }
              else {
                return 0; /* unchange order */
              }
            },
            removeItem: function(data) {
              selector.children('[value="' + data.value + '"]').remove();
              maxValue = selector.find(':last-child').val() ||
                parseInt(opts.firstValue) - 1;
            },
            removable: true
          });
          return {
            save: () => {
              const list = [];
              let value = "", valueName = "";
              const options = selector.children();

              ol.editableList('items').each(function(idx) {
                const i = $(this);
                const d = {};

                d.value = Number(i.find('.node-input-enum-value').val());
                d.name = i.find('.node-input-enum-name').val();

                /* assign the value name to the relevant select list entry */
                options[idx].dataset.name = d.name;

                list.push(d);
              });

              if (list.length > 0) {
                  const selected = selector.children('option:selected');
                  value = Number(selected.val());
                  valueName = selected.data('name');
              }
              return { list, value, valueName };
            },
            load: (data) => {
              if (data && Array.isArray(data.list)) {
                for (let i = 0; i < data.list.length; i++) {
                  ol.editableList('addItem', { ...data.list[i] });
                }

                /* update selector and maxValue */
                if (data.list.length > 0) {
                  selectedVal = data.value;
                  maxValue = selector.find(':last-child').val();

                  selector.find('option[value="' + selectedVal + '"]')
                  .prop('selected', true);

                  selector.on('change', function() {
                    selectedVal = $(this).find('option:selected').val();
                  });
                }
              }
            }
          }
        },
        /**
         * @typedef {{ index: string, name: string, type: number,
         *  unit: string, value: any, valueName?: string,
         *  enum?: Array<EnumData> }} Data
         * @param {{
         *  firstValue?: number | string  | null,
         *  negativeValue?: boolean | null,
         *  indexLabel?: string | null,
         *  nameLabel?: string | null,
         *  unitLabel?: string | null,
         *  listLabel?: string | null,
         *  parentName?: string | null,
         *  indexWidth?: string | null,
         *  unitWidth?: string | null
         * }} [options]
         * @return {{
         *  save: () => { list: Array<Data> },
         *  load: (list: Array<Data>) => void
         * }}
         */
        buildDataSetList: function(options) {
          opts = options || {}; /* default options */
          const regexp = opts.negativeValue ?
            dimXml.regExp.int : dimXml.regExp.uint;

          const dialogForm = $('#dialog-form');
          const ol = dialogForm
            .find('ol[data-id="node-input-ordered-list"]');

          if (opts.listLabel) {
            dialogForm.find('div[data-id="ordered-list-label"]')
            .text(opts.listLabel +
              (opts.parentName ? ' [ ' + opts.parentName + ' ]' : ''));
          }
          const firstValue = parseInt(opts.firstValue);
          let maxIndex = firstValue - 1 || -1;

          ol.css({
            minWidth: '480px',
            minHeight: '200px'
          })
          .editableList({
            addItem: function(row, index, data) {
              const indexWidth = opts.indexWidth || '130px';
              const unitWidth = opts.unitWidth || '120px';
              const indexLabel = opts.indexLabel || 'Index';
              const nameLabel = opts.nameLabel || 'Name';
              const unitLabel = opts.unitLabel || 'Unit';
              const lblWidth = '50px';
              const bpad = '6px';

              /* prepare and add a row to the container */
              row.css({
                overflow: "hidden",
                whiteSpace: "nowrap"
              });

              const item = $('<div>').appendTo(row);
              const baseData = $('<div>').appendTo(item)
                .css('padding-bottom', bpad);
              const valueData = $('<div>').appendTo(item);

              /* --- Index --- */
              const idx = $('<input>').attr('type', 'text')
                .addClass('node-input-dataset-index')
                .css({
                  display: 'inline-block',
                  width: 'calc(100% - ' + lblWidth + ')'
                });

              $('<div>')
              .append(
                $('<p>').css({
                  textAlign: 'center',
                  display: 'inline-block',
                  width: lblWidth
                })
                .text(indexLabel)
              )
              .append(idx)
              .css({
                display: 'inline-block',
                width: indexWidth
              })
              .appendTo(baseData)

              idx.typedInput({ type: 'int', types: [ { value: "int",
                label: "int",
                icon: "red/images/typedInput/09.png",
                validate: regexp } ]
              });

              /* set Index field */
              if (!data.hasOwnProperty('index')) {
                data = { index: ++maxIndex, name: "", type: "", value: "",
                  unit: "" };
              }
              idx.attr('data-prev', data.index).typedInput('value', data.index);

              /* --- Name --- */
              const name = $('<input>').attr('type', 'text')
                .addClass('node-input-dataset-name')
                .css({
                  display: 'inline-block',
                  width: 'calc(100% - ' + lblWidth + ')'
                });

              $('<div>')
              .append(
                $('<p>').css({
                  textAlign: 'center',
                  display: 'inline-block',
                  width: lblWidth
                })
                .text(nameLabel)
              )
              .append(name)
              .css({
                display: 'inline-block',
                width: 'calc(100% - ' + indexWidth + ')'
              })
              .appendTo(baseData);
              name.typedInput({ type: 'str' });

              /* --- Value --- */
              const value = $('<input>').attr('type', 'text')
                .addClass('node-input-dataset-value')
                .css({
                  width: 'calc(100% - ' + unitWidth + ')'
                })
                .appendTo(valueData)
                .typedInput({
                  types: [
                    { value: disXml.DataType.UINT8, label: "uint8",
                      validate: function(v) {
                        return dimXml.regExp.uint.test(v) && v >= 0 &&
                          v < 256;  /* 2^8 */
                      }
                    },
                    { value: disXml.DataType.UINT16, label: "uint16",
                      validate: function(v) {
                        return dimXml.regExp.uint.test(v) && v >= 0 &&
                          v < 65536; /* 2^16 */
                      }
                    },
                    { value: disXml.DataType.UINT32, label: "uint32",
                      validate: function(v) {
                        return dimXml.regExp.uint.test(v) && v >= 0 &&
                          v < 4294967296; /* 2^32 */
                      }
                    },
                    { value: disXml.DataType.UINT64, label: "uint64",
                      validate: function(v) {
                        return dimXml.regExp.uint.test(v) &&
                          v >= 0 && v < 18446744073709551616n; /* BigInt(2^64) */
                      }
                    },
                    { value: disXml.DataType.INT8, label: "int8",
                      validate: function(v) {
                        return dimXml.regExp.int.test(v) &&
                          v >= -128 && v < 128; /* [-2^7, 2^7) */
                      }
                    },
                    { value: disXml.DataType.INT16, label: "int16",
                      validate: function(v) {
                        return dimXml.regExp.int.test(v) &&
                          v >= -32768 && v < 32768; /* [-2^15, 2^15) */
                      }
                    },
                    { value: disXml.DataType.INT32, label: "int32",
                      validate: function(v) {
                        return dimXml.regExp.int.test(v) &&
                        v >= -2147483648 && v < 2147483648; /* [-2^31, 2^31) */
                      }
                    },
                    { value: disXml.DataType.INT64, label: "int64",
                      validate: function(v) {
                        return dimXml.regExp.int.test(v) &&
                          v >= -9223372036854775808n && v < 9223372036854775808n; /* [-2^63, 2^63) */
                      }},
                    { value: disXml.DataType.FLOAT, label: "float",
                      validate: function(v) {
                        return v!=='' && !isNaN(v) &&
                          v>= -3.40282e+38 && v<= 3.40282e+38;
                      }
                    },
                    { value: disXml.DataType.DOUBLE, label: "double",
                      validate: function(v) {
                        return v!=='' && !isNaN(v);
                      }
                    },
                    { value: disXml.DataType.STRING, label: "string" },
                    { value: disXml.DataType.ENUM, label: "enum", hasValue: false,
                      expand: function() {
                        const enumData = this;
                        let val;
                        try {
                          val = JSON.parse(this.value() || "{}");
                        }
                        catch (err){
                          RED.notify(RED._("node-red:common.notification.error",
                            { message: RED._('node-red-dim-xml/disXmlDataSet:disXmlDataSet.error.json-parse',
                              { idx: data.index, err: err.toString() })
                            }), "error");
                          val = {};
                        }
                        RED.editor.showTypeEditor(disXml.editor.enumType, {
                          listOpts: {
                            firstValue: 0,
                            negativeValue: true,
                            valueWidth: '80px',
                            selectorLabel: RED._('node-red-dim-xml/disXmlDataSet:disXmlDataSet.label.enum-data.select'),
                            valueLabel: RED._('node-red-dim-xml/disXmlDataSet:disXmlDataSet.label.enum-data.header-value'),
                            strValueLabel: RED._('node-red-dim-xml/disXmlDataSet:disXmlDataSet.label.enum-data.header-value-name'),
                            listLabel: RED._('node-red-dim-xml/disXmlDataSet:disXmlDataSet.label.enum-data.title'),
                            parentName: name.val()
                          },
                          title: RED._('node-red-dim-xml/disXmlDataSet:disXmlDataSet.label.enum-data.title'),
                          value: val,
                          complete: function(v) {
                            enumData.value(JSON.stringify(v));
                          }
                        });
                      }
                    },
                    { value: disXml.DataType.BOOL, label: "bool",
                      options: [ "true", "false" ]
                    },
                    { value: disXml.DataType.NESTED, label: "nested", hasValue: false,
                      expand: function() {
                        const childData = this;
                        let val;
                        try {
                          val = JSON.parse(this.value() || "[]");
                        }
                        catch (err){
                          RED.notify(RED._("node-red:common.notification.error",
                            { message: RED._('node-red-dim-xml/disXmlDataSet:disXmlDataSet.error.json-parse',
                              { idx: data.index, err: err.toString() })
                            }), "error");
                          val = [];
                        }
                        RED.editor.showTypeEditor(disXml.editor.nestedType, {
                          listOpts: {
                            firstValue: firstValue,
                            indexLabel: indexLabel,
                            nameLabel: nameLabel,
                            unitLabel: unitLabel,
                            indexWidth: indexWidth,
                            unitWidth: unitWidth,
                            listLabel: RED._('node-red-dim-xml/disXmlDataSet:disXmlDataSet.label.nested-data.title'),
                            parentName: name.val()
                          },
                          title: RED._('node-red-dim-xml/disXmlDataSet:disXmlDataSet.label.nested-data.title'),
                          value: val,
                          complete: function(v) {
                            childData.value(JSON.stringify(v));
                          }
                        });
                      }
                    },
                  ]
                });

              /* --- Unit --- */
              const unit = $('<input>').attr('type', 'text')
                .addClass('node-input-dataset-unit')
                .css({
                  display: 'inline-block',
                  width: 'calc(100% - ' + lblWidth + ')'
                });

              $('<div>').addClass('node-div-data-unit')
              .append(
                $('<p>').css({
                  textAlign: 'center',
                  display: 'inline-block',
                  width: lblWidth
                })
                .text(unitLabel)
              )
              .append(unit)
              .css({
                display: 'inline-block',
                width: unitWidth
              })
              .appendTo(valueData);

              value.on('change', function(event, value) {
                if (value === disXml.DataType.NESTED) {
                  unit.prop('disabled', true).val('');
                }
                else {
                  unit.prop('disabled', false);
                }
              });

              /* set remaining fields */
              name.typedInput('value', data.name);
              value.typedInput('type', data.type);
              unit.val(data.unit);

              if (data.type === disXml.DataType.NESTED) {
                data.value = JSON.stringify(data.value) || "[]";
                value.typedInput('value', data.value);
              }
              else if (data.type === disXml.DataType.ENUM) {
                data.enum = data.enum || [];
                data.valueName = data.valueName || "";
                data.value = data.value || "";
                const v = { list: data.enum, value: data.value,
                  valueName: data.valueName };
                value.typedInput('value', JSON.stringify(v) || "{}");
              }
              else {
                value.typedInput('value', data.value);
              }

              /* update item data */
              $(row).data('data', data);

              const changeValue = function() {
                const v = $(this).typedInput('value');
                const prev = $(this).attr('data-prev');
                let err = "";
                if (regexp.test(v)) {
                  /* check for duplicate values */
                  if (ol
                    .find('input.node-input-dataset-index[data-prev="' + v + '"]')
                    .length === 0) {
                    /* update data and prev value*/
                    $(row).data('data').index = v;
                    $(this).attr('data-prev', v);

                    ol.editableList('sort');
                    if (v > maxIndex) { maxIndex = v; }
                  }
                  else {
                    err = RED._('node-red-dim-xml/dimXmlConf:dimXmlConf.error.dup-value');
                  }
                }
                else {
                  err = RED._('node-red-dim-xml/dimXmlConf:dimXmlConf.error.invalid-value');
                }

                if (err) {
                  /* avoids indefinite recursion */
                  $(this).off('change').typedInput('value', prev);
                  $(this).on('change', changeValue);
                  $('<div>').addClass('dim-msg-error')
                  .css({ top: '1px', left: 'calc( 15px + ' + lblWidth + ')',
                    marginBottom: '7px', display: 'none' })
                  .text(err).insertAfter(baseData).show('fast').delay(3000)
                  .hide('fast', function() {
                    $(this).remove();
                  });
                }
              }
              idx.on('change', changeValue);
              ol.editableList('show', $(row).data('data')); /* scroll on Add */
            },
            sort: function(dataA, dataB) {
              if (dataA.index && dataB.index) {
                return dataA.index - dataB.index;
              }
              else {
                return 0; /* unchange order */
              }
            },
            removeItem: function(data) {
              const lastItemData = ol.find('.red-ui-editableList-item-content')
                .last().data('data');

              maxIndex = lastItemData ? lastItemData.index : firstValue - 1;
            },
            removable: true
          });

          return {
            save: () => {
              const list = [];
              ol.editableList('items').each(function(idx) {
                const i = $(this);
                const d = {};

                d.index = Number(i.find('.node-input-dataset-index').typedInput('value'));
                d.name = i.find('.node-input-dataset-name').val();
                d.type = i.find('.node-input-dataset-value').typedInput('type');
                d.unit = i.find('.node-input-dataset-unit').val();
                const val = i.find('.node-input-dataset-value').typedInput('value');

                let errMsg = "";
                switch(d.type) {
                case disXml.DataType.NESTED:
                  try {
                    d.value = JSON.parse(val || "[]");
                  }
                  catch (err) {
                    errMsg = err.toString();
                    d.value = [];
                  }
                  break;
                case disXml.DataType.ENUM:
                  let parsedVal;
                  try {
                    parsedVal = JSON.parse(val ||
                      '{ "list": [], "value": "", "valueName": "" }');
                    d.enum = parsedVal.list;
                    d.valueName = parsedVal.valueName;
                    d.value = parsedVal.value;
                  }
                  catch (err) {
                    errMsg = err.toString();
                    d.enum = [];
                    d.valueName = d.value = "";
                  }
                  break;
                case disXml.DataType.INT64:
                case disXml.DataType.INT32:
                case disXml.DataType.INT16:
                case disXml.DataType.INT8:
                case disXml.DataType.DOUBLE:
                case disXml.DataType.FLOAT:
                case disXml.DataType.ENUM:
                case disXml.DataType.UINT32:
                case disXml.DataType.UINT64:
                case disXml.DataType.UINT8:
                case disXml.DataType.UINT16:
                  d.value = Number(val);
                  break;
                case disXml.DataType.BOOL:
                  d.value = /^true$/i.test(val);
                  break;
                default:
                  d.value = val;
                }
                if (errMsg) {
                  RED.notify(RED._("node-red:common.notification.error",
                    { message: RED._("node-red-dim-xml/disXmlDataSet:disXmlDataSet.error.json-parse",
                    { idx: d.index, err: errMsg }) }), "error");
                }

                list.push(d);
              });
              return list;
            },
            load: (dataset) => {
              if (Array.isArray(dataset)) {
                for (let i = 0; i < dataset.length; i++) {
                  ol.editableList('addItem', { ...dataset[i] });
                }

                maxIndex = (dataset.length > 0) ?
                  dataset[dataset.length - 1].index : firstValue - 1;
              }
            }
          }
        }
      }
    },
    dicXml = {
      regExp: {
        srvName: new RegExp(dimXml.regExp.srvName),
        srvDefFormat: new RegExp("\\s\\[\\s" + dimXml.regExp.srvDefFormat + "\\s\\]$"),
        srvDefFormatIO: new RegExp("\\s\\[\\s" + dimXml.regExp.srvDefFormat + "," +
          dimXml.regExp.srvDefFormat + "\\s\\]$")
      }
    };
    dimXmlPromise.resolve(dimXml);

    class DataEditor {
      constructor(buildList) {
        this._buildList = buildList;
      }

      show(options) {
        const buildList = this._buildList;
        let l;

        if ($('script[data-template-name="_dim-xml-editor"]').length === 0) {
          $(disXml.editor.template).appendTo("#red-ui-editor-node-configs");
        }
        RED.view.state(RED.state.EDITING);

        var trayOptions = {
          title: options.title,
          width: "inherit",
          buttons: [
            {
              id: "node-dialog-cancel",
              text: RED._("common.label.cancel"),
              click: function() { RED.tray.close(); }
            },
            {
              id: "node-dialog-ok",
              text: RED._("common.label.done"),
              class: "primary",
              click: function() {
                options.complete(l.save());
                RED.tray.close();
              }
            }
          ],
          open: function(tray) {
            RED.editor.buildEditForm(tray.find('.red-ui-tray-body'),
              'dialog-form', '_dim-xml-editor', 'editor');

            l = buildList(options.listOpts);

            l.load(options.value)
          },
          resize: dimXml.utils.resizeDialog,
          close: function() {
            if (options.onclose) { options.onclose(); }
          }
        }
        RED.tray.show(trayOptions);
      }
    }

    RED.editor.registerTypeEditor(disXml.editor.enumType,
      new DataEditor(disXml.editor.buildEnumList));
    RED.editor.registerTypeEditor(disXml.editor.nestedType,
      new DataEditor(disXml.editor.buildDataSetList));
</script>
